/*===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================
*
*/

#ifndef _h_klib_status_priv_
#define _h_klib_status_priv_

#include <klib/defs.h>
#include <klib/status.h>

#ifdef __cplusplus
extern "C" {
#endif
#if 0
}
#endif



rc_t DefaultStatusDriver (void * ignored, const char * buffer, size_t count);



size_t DbgBuildString (char * pout, size_t max, const char * fmt, ...);



/* write 'count' bytes starting at 'buf' to the file stream represented by 'fd' */
rc_t status_write (void * self, const char * buf, size_t count, size_t * num_writ);

/* fix up windows printf shortcomings for integer types 
 * current format is len long at fmt with max max size for the format
 * len is updated to new length if fmt is changed
 */
void kprintf_int_fixup   (char * fmt, size_t * len, size_t max);
void kprintf_float_fixup (char * fmt, size_t * len, size_t max);
void kprintf_char_fixup  (char * fmt, size_t * len, size_t max);


#ifdef __cplusplus
}
#endif

#endif /*  _h_klib_status_priv_ */
